;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;                                                                       ;;
;;;                Centre for Speech Technology Research                  ;;
;;;                     University of Edinburgh, UK                       ;;
;;;                       Copyright (c) 1996,1997                         ;;
;;;                        All Rights Reserved.                           ;;
;;;                                                                       ;;
;;;  Permission to use, copy, modify, distribute this software and its    ;;
;;;  documentation for research, educational and individual use only, is  ;;
;;;  hereby granted without fee, subject to the following conditions:     ;;
;;;   1. The code must retain the above copyright notice, this list of    ;;
;;;      conditions and the following disclaimer.                         ;;
;;;   2. Any modifications must be clearly marked as such.                ;;
;;;   3. Original authors' names are not deleted.                         ;;
;;;  This software may not be used for commercial purposes without        ;;
;;;  specific prior written permission from the authors.                  ;;
;;;                                                                       ;;
;;;  THE UNIVERSITY OF EDINBURGH AND THE CONTRIBUTORS TO THIS WORK        ;;
;;;  DISCLAIM ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING      ;;
;;;  ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT   ;;
;;;  SHALL THE UNIVERSITY OF EDINBURGH NOR THE CONTRIBUTORS BE LIABLE     ;;
;;;  FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES    ;;
;;;  WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN   ;;
;;;  AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,          ;;
;;;  ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF       ;;
;;;  THIS SOFTWARE.                                                       ;;
;;;                                                                       ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;
;;;   A hand specified tree to predict zcore durations
;;;
;;;

(set! itc_kh_po::zdur_tree
 '
((name is pau)
 ((emph_sil is +)
  ((1.0))
  ((p.R:SylStructure.parent.parent.pbreak is BB)
   ((2.0))
   ((p.R:SylStructure.parent.parent.pbreak is B)
     ((1.0))
     ((0.8)))))
     
   ((R:SylStructure.parent.R:Syllable.p.syl_break > 1 ) ;; clause initial
    ((R:SylStructure.parent.stress is 1)
     ((1.4))
     ((1.2)))
    ((R:SylStructure.parent.syl_break > 1) ;; clause final
     ((R:SylStructure.parent.stress is 1)
      ((1.4))
      ((1.2)))
     ((R:SylStructure.parent.n.parent.name is 0)	;; last syllable
       ((R:SylStructure.parent.p.parent.name is 0)	;; first syllable
         ((1.5))
         ((1.4)))
       ((R:SylStructure.parent.stress is 1)
        ((ph_vc is +)
         ((1.4))
         ((1.2)))
        ((1.0))))))))

(set! itc_kh_po::phone_durs
 ;; should be hand specified
  '(
    (pau 0.0 0.250)
    
	(i  0.0 0.092)
	(i: 0.0 0.122)
	(e  0.0 0.087)
	(e: 0.0 0.114)
	(e.: 0.0 0.112)
	(aE 0.0 0.136)
	(E: 0.0 0.120)
	(a  0.0 0.066)
	(a: 0.0 0.132)
	(ix 0.0 0.068)
	(ix: 0.0 0.156)
	(@  0.0 0.083)
	(W: 0.0 0.119)
	(@: 0.0 0.196)
	(A  0.0 0.047)
	(A: 0.0 0.162)
	(u  0.0 0.048)
	(u: 0.0 0.154)
	(o  0.0 0.066)
	(o: 0.0 0.141)
	(O  0.0 0.070)
	(O: 0.0 0.137)
	(Oo 0.0 0.118)
	(iVx 0.0 0.140)
	(Ea 0.0 0.090)
	(i@ 0.0 0.127)
	(ao 0.0 0.133)
	(a@ 0.0 0.170)
	(ix@ 0.0 0.142)
	(u@ 0.0 0.183)
	(oa 0.0 0.149)
	(@R 0.0 0.156)

	(p  0.0 0.075)
	(b  0.0 0.076)
	(ph 0.0 0.084)
	(t  0.0 0.073)
	(d  0.0 0.072)
	(th 0.0 0.082)
	(c  0.0 0.073)
	(ch 0.0 0.087)
	(k  0.0 0.079)
	(kh 0.0 0.085)
	(?  0.0 0.076)
	(m  0.0 0.095)
	(n  0.0 0.086)
	(n. 0.0 0.086)
	(N  0.0 0.083)
	(r  0.0 0.078)
	(s  0.0 0.106)
	(h  0.0 0.096)
	(l  0.0 0.092)
	(w  0.0 0.090)
	(j  0.0 0.082)	
 ;;   ...  ;; the other phones
   )
 ;; But this will fake it until you build a duration model 
; (mapcar
;  (lambda (p)
;    (list (car p) 0.0 0.100))
;  (cadr (assoc_string 'phones (PhoneSet.description ))))
)

(provide 'itc_kh_po_durdata)
