;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;                                                                     ;;;
;;;                     Carnegie Mellon University                      ;;;
;;;                  and Alan W Black and Kevin Lenzo                   ;;;
;;;                      Copyright (c) 1998-2000                        ;;;
;;;                        All Rights Reserved.                         ;;;
;;;                                                                     ;;;
;;; Permission is hereby granted, free of charge, to use and distribute ;;;
;;; this software and its documentation without restriction, including  ;;;
;;; without limitation the rights to use, copy, modify, merge, publish, ;;;
;;; distribute, sublicense, and/or sell copies of this work, and to     ;;;
;;; permit persons to whom this work is furnished to do so, subject to  ;;;
;;; the following conditions:                                           ;;;
;;;  1. The code must retain the above copyright notice, this list of   ;;;
;;;     conditions and the following disclaimer.                        ;;;
;;;  2. Any modifications must be clearly marked as such.               ;;;
;;;  3. Original authors' names are not deleted.                        ;;;
;;;  4. The authors' names are not used to endorse or promote products  ;;;
;;;     derived from this software without specific prior written       ;;;
;;;     permission.                                                     ;;;
;;;                                                                     ;;;
;;; CARNEGIE MELLON UNIVERSITY AND THE CONTRIBUTORS TO THIS WORK        ;;;
;;; DISCLAIM ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING     ;;;
;;; ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT  ;;;
;;; SHALL CARNEGIE MELLON UNIVERSITY NOR THE CONTRIBUTORS BE LIABLE     ;;;
;;; FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES   ;;;
;;; WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN  ;;;
;;; AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,         ;;;
;;; ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF      ;;;
;;; THIS SOFTWARE.                                                      ;;;
;;;                                                                     ;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;
;;; Lexicon, LTS and Postlexical rules for itc_kh
;;;

;;; Load any necessary files here

(define (itc_kh_addenda)
  "(itc_kh_addenda)
Basic lexicon should (must ?) have basic letters, symbols and punctuation."

;;; Pronunciation of letters in the alphabet
;(lex.add.entry '("a" nn (((a) 0))))
;(lex.add.entry '("b" nn (((b e) 0))))
;(lex.add.entry '("c" nn (((th e) 0))))
;(lex.add.entry '("d" nn (((d e) 0))))
;(lex.add.entry '("e" nn (((e) 0))))
; ...

;;; Symbols ...
;(lex.add.entry 
; '("*" n (((a s) 0) ((t e) 0) ((r i1 s) 1)  ((k o) 0))))
;(lex.add.entry 
; '("%" n (((p o r) 0) ((th i e1 n) 1) ((t o) 0))))

;; Basic punctuation must be in with nil pronunciation
(lex.add.entry '("." punc nil))
;(lex.add.entry '("." nn (((p u1 n) 1) ((t o) 0))))
(lex.add.entry '("'" punc nil))
(lex.add.entry '(":" punc nil))
(lex.add.entry '(";" punc nil))
(lex.add.entry '("," punc nil))
;(lex.add.entry '("," nn (((k o1) 1) ((m a) 0))))
(lex.add.entry '("-" punc nil))
(lex.add.entry '("\"" punc nil))
(lex.add.entry '("`" punc nil))
(lex.add.entry '("?" punc nil))
(lex.add.entry '("!" punc nil))
(lex.add.entry '("៕" punc (((kh a n) 0) ((c A p) 1))))
(lex.add.entry '("0" nil (((s o: n) 1))))
(lex.add.entry '("1" nil (((m u@ j) 1))))
(lex.add.entry '("2" nil (((p i:) 1))))
(lex.add.entry '("3" nil (((b e j) 1))))
(lex.add.entry '("4" nil (((b u@ n) 1))))
(lex.add.entry '("5" nil (((p r a m) 1))))
(lex.add.entry '("6" nil (((p r a m) 0) ((m u@ j) 1))))
(lex.add.entry '("7" nil (((p r a m) 0) ((p i:) 1))))
(lex.add.entry '("8" nil (((p r a m) 0) ((b e j) 1))))
(lex.add.entry '("9" nil (((p r a m) 0) ((b u@ n) 1))))
(lex.add.entry '("a" nil (((? e:) 1))))
(lex.add.entry '("b" nil (((b i:) 1))))
(lex.add.entry '("c" nil (((s i:) 1))))
(lex.add.entry '("d" nil (((d i:) 1))))
(lex.add.entry '("e" nil (((? i:) 1))))
(lex.add.entry '("f" nil (((? e: f) 1))))
(lex.add.entry '("g" nil (((c i:) 1))))
(lex.add.entry '("h" nil (((? e: c) 1))))
(lex.add.entry '("i" nil (((? a: j) 1))))
(lex.add.entry '("j" nil (((c e:) 1))))
(lex.add.entry '("k" nil (((kh e:) 1))))
(lex.add.entry '("l" nil (((? e: l) 1))))
(lex.add.entry '("m" nil (((? e: m) 1))))
(lex.add.entry '("n" nil (((? e: n) 1))))
(lex.add.entry '("o" nil (((? Oo) 1))))
(lex.add.entry '("p" nil (((p i:) 1))))
(lex.add.entry '("q" nil (((k j u:) 1))))
(lex.add.entry '("r" nil (((? A:) 1))))
(lex.add.entry '("s" nil (((? e: s) 1))))
(lex.add.entry '("t" nil (((th i:) 1))))
(lex.add.entry '("u" nil (((j u:) 1))))
(lex.add.entry '("v" nil (((w i:) 1))))
(lex.add.entry '("w" nil (((d a p) 1) ((b @ l) 0) ((j u:) 1))))
(lex.add.entry '("x" nil (((? e k s) 1))))
(lex.add.entry '("y" nil (((w a: j) 1))))
(lex.add.entry '("z" nil (((h s i: d) 1))))
(lex.add.entry '("@" nil (((? aE t) 1))))
(lex.add.entry '("ា" nil (((s r a ?) 0) ((? a:) 1))))
(lex.add.entry '("ិ" nil (((s r a ?) 0) ((? e ?) 1))))
(lex.add.entry '("ី" nil (((s r a ?) 0) ((? e j) 1))))
(lex.add.entry '("ឹ" nil (((s r a ?) 0) ((? @ ?) 1))))
(lex.add.entry '("ឺ" nil (((s r a ?) 0) ((? E:) 1))))
(lex.add.entry '("ុ" nil (((s r a ?) 0) ((? o ?) 1))))
(lex.add.entry '("ូ" nil (((s r a ?) 0) ((? Oo) 1))))
(lex.add.entry '("ួ" nil (((s r a ?) 0) ((? u@) 1))))
(lex.add.entry '("ើ" nil (((s r a ?) 0) ((? a@) 1))))
(lex.add.entry '("ឿ" nil (((s r a ?) 0) ((? ix@) 1))))
(lex.add.entry '("ៀ" nil (((s r a ?) 0) ((? iVx) 1))))
(lex.add.entry '("េ" nil (((s r a ?) 0) ((? e:) 1))))
(lex.add.entry '("ែ" nil (((s r a ?) 0) ((? aE) 1))))
(lex.add.entry '("ៃ" nil (((s r a ?) 0) ((? a j) 1))))
(lex.add.entry '("ោ" nil (((s r a ?) 0) ((? ao) 1))))
(lex.add.entry '("ៅ" nil (((s r a ?) 0) ((? a w) 1))))
(lex.add.entry '("ុំ" nil (((s r a ?) 0) ((? o m) 1))))
(lex.add.entry '("ំ" nil (((s r a ?) 0) ((? A m) 1))))
(lex.add.entry '("ាំ" nil (((s r a ?) 0) ((? a m) 1))))
(lex.add.entry '("ះ" nil (((s r a ?) 0) ((? a h) 1))))
(lex.add.entry '("ុះ" nil (((s r a ?) 0) ((? o h) 1))))
(lex.add.entry '("េះ" nil (((s r a ?) 0) ((? e h) 1))))
(lex.add.entry '("ោះ" nil (((s r a ?) 0) ((? a h) 1))))
(lex.add.entry '("ៈ" nil (((j u ?) 1) ((k a) 0) ((l Ea ?) 1) ((p @ n) 1) ((t u ?) 1))))
(lex.add.entry '("៊" nil (((t r e j) 0) ((s a p) 1))))
(lex.add.entry '("៉" nil (((s a) 0) ((l a p) 1) ((p i:) 1))))
(lex.add.entry '("់" nil (((b A n) 0) ((t A ?) 1))))
(lex.add.entry '("ៗ" nil (((l e: c) 0) ((t Oo) 1))))
(lex.add.entry '("៍" nil (((t oa n) 0) ((d a ?) 1) ((kh i@ t) 1))))
(lex.add.entry '("័" nil (((s a n.) 0) ((n. Oo k) 1) ((s a n.) 0) ((n. a:) 1))))
(lex.add.entry '("៏" nil (((l e: k) 0) ((p r a m) 1) ((b e j) 1))))
(lex.add.entry '("៌" nil (((r O:) 0) ((b a: t) 1))))
(lex.add.entry '(":" nil (((c o c) 0) ((p i:) 1))))
(lex.add.entry '("=" nil (((s m a@) 1))))
(lex.add.entry '("*" nil (((ph k a: j) 1))))
(lex.add.entry '("-" nil (((d A: ?) 1))))
(lex.add.entry '("/" nil (((c a@ c) 1))))
(lex.add.entry '("+" nil (((b Oo k) 1))))
(lex.add.entry '("អ" nil (((? A:) 1))))
(lex.add.entry '("្ក" nil (((c @: N) 0) ((k A:) 1))))
(lex.add.entry '("្ខ" nil (((c @: N) 0) ((kh A:) 1))))
(lex.add.entry '("្គ" nil (((c @: N) 0) ((k O:) 1))))
(lex.add.entry '("្ឃ" nil (((c @: N) 0) ((kh O:) 1))))
(lex.add.entry '("្ង" nil (((c @: N) 0) ((N O:) 1))))
(lex.add.entry '("្ច" nil (((c @: N) 0) ((c A:) 1))))
(lex.add.entry '("្ឆ" nil (((c @: N) 0) ((ch A:) 1))))
(lex.add.entry '("្ជ" nil (((c @: N) 0) ((c O:) 1))))
(lex.add.entry '("្ឈ" nil (((c @: N) 0) ((ch O:) 1))))
(lex.add.entry '("្ញ" nil (((c @: N) 0) ((n. O:) 1))))
(lex.add.entry '("្ដ" nil (((c @: N) 0) ((d A:) 1))))
(lex.add.entry '("្ឋ" nil (((c @: N) 0) ((th A:) 1))))
(lex.add.entry '("្ឌ" nil (((c @: N) 0) ((d O:) 1))))
(lex.add.entry '("្ឍ" nil (((c @: N) 0) ((th O:) 1))))
(lex.add.entry '("្ណ" nil (((c @: N) 0) ((n A:) 1))))
(lex.add.entry '("្ត" nil (((c @: N) 0) ((t A:) 1))))
(lex.add.entry '("្ថ" nil (((c @: N) 0) ((th A:) 1))))
(lex.add.entry '("្ទ" nil (((c @: N) 0) ((t O:) 1))))
(lex.add.entry '("្ធ" nil (((c @: N) 0) ((th O:) 1))))
(lex.add.entry '("្ន" nil (((c @: N) 0) ((n O:) 1))))
(lex.add.entry '("្ប" nil (((c @: N) 0) ((b A:) 1))))
(lex.add.entry '("្ផ" nil (((c @: N) 0) ((ph A:) 1))))
(lex.add.entry '("្ព" nil (((c @: N) 0) ((p O:) 1))))
(lex.add.entry '("្ភ" nil (((c @: N) 0) ((ph O:) 1))))
(lex.add.entry '("្ម" nil (((c @: N) 0) ((m O:) 1))))
(lex.add.entry '("្យ" nil (((c @: N) 0) ((j O:) 1))))
(lex.add.entry '("្រ" nil (((c @: N) 0) ((r O:) 1))))
(lex.add.entry '("្ល" nil (((c @: N) 0) ((l O:) 1))))
(lex.add.entry '("្វ" nil (((c @: N) 0) ((w O:) 1))))
(lex.add.entry '("្ស" nil (((c @: N) 0) ((s A:) 1))))
(lex.add.entry '("្ហ" nil (((c @: N) 0) ((h A:) 1))))
(lex.add.entry '("្ឡ" nil (((c @: N) 0) ((l A:) 1))))
(lex.add.entry '("្អ" nil (((c @: N) 0) ((? A:) 1))))
)

(require 'lts)

;; added to do lts...
(lts.ruleset 
    itc_kh_lts_rules 
    (
    	(v a i o)
    )
    (
        ( [ o ] = o: )
        ( [ a ] = a: )
        ( [ "ក" ] = k A: )
    )
)

;;;  Function called when word not found in lexicon
;;;  and you've trained letter to sound rules
(define (itc_kh_lts_function word features)
  "(itc_kh_lts_function WORD FEATURES)
Return pronunciation of word not in lexicon."
;;  (if (not boundp 'itc_kh_lts_rules)
;;      (require 'itc_kh_lts_rules))
      (load (path-append itc_kh_po_dir "festvox/itc_kh_lts_rules.scm"))
  (let ((dword (downcase word)) (phones) (syls))
;;    (set! phones (lts_predict dword itc_kh_lts_rules))
    (set! phones (lts_predict word itc_kh_lts_rules))
;;    (set! phones (lts.apply word 'itc_kh_lts_rules))
    (if (equal? phones nil)
        (set! phones (list 'h )))
    (set! syls (itc_kh_lex_syllabify_phstress phones))
    (list word features syls)))

;; utf8 letter based one
;(define (itc_kh_lts_function word features)
;  "(itc_kh_lts_function WORD FEATURES)
;Return pronunciation of word not in lexicon."
;  (let ((dword word) (phones) (syls))
;    (set! phones (utf8explode dword))
;    (set! syls (itc_kh_lex_syllabify_phstress phones))
;    (list word features syls)))

(define (itc_kh_is_vowel x)
  (string-equal "+" (phone_feature x "vc")))

(define (itc_kh_contains_vowel l)
  (member_string
   t
   (mapcar (lambda (x) (itc_kh_is_vowel x)) l)))

;; added by Meng (02/04/09)
;; find number of consonants before a vowel is reached
(define (num_cons_until_vowels remainder)
  (cond
    ((itc_kh_is_vowel (car remainder))
      0)
    (t
      (+ 1 (num_cons_until_vowels (cdr remainder))))))

(define (itc_kh_lex_sylbreak currentsyl remainder)
  "(itc_kh_lex_sylbreak currentsyl remainder)
t if this is a syl break, nil otherwise."
  (cond
   ((not (itc_kh_contains_vowel remainder))
    nil)
   ((not (itc_kh_contains_vowel currentsyl))
    nil)
    ;; overly naive, I mean wrong
    ;; added by Meng (02/04/09)
    ;;(1)When two identical consonants appear next to each other, one of them is considered as coda of the previous syllable and another is onset of the next syllable.
    ;;(2)The onset contains at least one consonant.
    ;;(3)The maximum number of consonant found in the onset is three.
    ;;(4)The coda contains at most one consonant.
    ;;(5)If the nucleus is a short vowel, then the coda must contain one consonant.
    ;;(6)All these consonants /ɲ   ŋ   n   j   w/ cannot be the first consonant of the cluster.
    ;;(7)Consider …C1VC2…, if C2 is one of the nasal consonants / ɲ   ŋ   n   m/, then C2 must be coda of that syllable. 
   ((itc_kh_is_vowel (car currentsyl))
     (cond
       ((eq (car remainder) (car (cdr remainder)))  ;;(1)
        nil)
       ((eq 3 (num_cons_until_vowels remainder))
        (cond
          ((and (and (eq (car remainder) "s") (eq (nth 2 remainder) "r")) (or (eq (nth 1 remainder) "t") ((eq (nth 1 remainder) "k")))) 
          ;;(2) only str and skr are possible consonant clusters
           t)
          (t
           nil)
        )
       )
       ((itc_kh_is_vowel (nth 1 remainder))  ;; cv1cv2 ==> cv1.cv2
        t)
       ((member (car remainder) '("n." "N" "n" "j" "w" "m")) ;; (6) and (7)
        nil)
       ((eq 4 (num_cons_until_vowels remainder))     ;;(3)
        nil) 
     )
   )  
   ((not (itc_kh_is_vowel (car currentsyl)))
    t)
   (t 
	nil)

  )
)

;; added by Meng to find stress (02/04/09)
;;	Word which contains two syllables, the stress is on the last syllable of the word
;;	Wrod with 3 syl, the stresses are on the first and last syllable
;;	Word containing four syllables has stresses on the second and last syllable
;;	Word with more than 4 syl, the stresses are on every two syllable in the word i.e. 2nd, 4th, 6th ... syllable
(define (findstress syls)
  (set! len (length syls))
  (cond
	((or (eq len 1) (eq len 3)) 
		(set! stress 0)
		(mapcar (lambda (syl) (set! stress (- 1 stress)) (list (car syl) stress)) syls)
	)
	(t
		(set! stress 1)
		(set! lastsyl (car (reverse syls)))
		(set! lastsylstress (list (car lastsyl) 1))
		(set! nolast (reverse (cdr (reverse syls))))
		(set! nolaststress (mapcar (lambda (syl) (set! stress (- 1 stress)) (list (car syl) stress)) nolast))
		(reverse (cons lastsylstress (reverse nolaststress)))
	)
  )
)
;; end find stress=============

(define (itc_kh_lex_syllabify_phstress phones)
 (let ((syl nil) (syls nil) (p phones) (stress 0))
    (while p
     (set! syl nil)
     (set! stress 0)
     (while (and p (not (itc_kh_lex_sylbreak syl p)))
       (if (string-matches (car p) "xxxx")
           (begin
             ;; whatever you do to identify stress
             (set! stress 1)
             (set syl (cons (car p-stress) syl)))
           (set! syl (cons (car p) syl)))
       (set! p (cdr p)))
     (set! syls (cons (list (reverse syl) stress) syls)))
;     (print (list syl p))
;     (print (not (itc_kh_lex_sylbreak syl p)))
;     (print (and p (not (itc_kh_lex_sylbreak syl p))))
     ;; do the stress assignment
     ;;(set! syls (reverse syls))
     ;;(set! len (length syls))
     ;;(cond
    (findstress (reverse syls))))


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;
;;; OR: Hand written letter to sound rules
;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

; ;;;  Function called when word not found in lexicon
; (define (itc_kh_lts_function word features)
;   "(itc_kh_lts_function WORD FEATURES)
; Return pronunciation of word not in lexicon."
;   (format stderr "failed to find pronunciation for %s\n" word)
;   (let ((dword (downcase word)))
;     ;; Note you may need to use a letter to sound rule set to do
;     ;; casing if the language has non-ascii characters in it.
;     (if (lts.in.alphabet word 'itc_kh)
; 	(list
; 	 word
; 	 features
; 	 ;; This syllabification is almost certainly wrong for
; 	 ;; this language (its not even very good for English)
; 	 ;; but it will give you something to start off with
; 	 (lex.syllabify.phstress
; 	   (lts.apply word 'itc_kh)))
; 	(begin
; 	  (format stderr "unpronouncable word %s\n" word)
; 	  ;; Put in a word that means "unknown" with its pronunciation
; 	  '("nepoznat" nil (((N EH P) 0) ((AO Z) 0) ((N AA T) 0))))))
; )

; ;; You may or may not be able to write a letter to sound rule set for
; ;; your language.  If its largely lexicon based learning a rule
; ;; set will be better and easier that writing one (probably).
; (lts.ruleset
;  itc_kh
;  (  (Vowel WHATEVER) )
;  (
;   ;; LTS rules 
;   ))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;
;;; Postlexical Rules 
;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(define (itc_kh::postlex_rule1 utt)
  "(itc_kh::postlex_rule1 utt)
A postlexical rule form correcting phenomena over word boundaries."
  (mapcar
   (lambda (s)
     ;; do something
     ;; map e. to e and f to p because we haven't yet recorded the phone e. and f
       (if (string-equal "e." (item.name s))
           (item.set_name s "e"))
       (if (string-equal "f" (item.name s))
           (item.set_name s "p"))
     )
   (utt.relation.items utt 'Segment))
   utt)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;
;;; Lexicon definition
;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(set! itc_kh_po::dir itc_kh_po_dir)

(lex.create "itc_kh")
(lex.set.phoneset "itc_kh")
;;(lex.set.compile.file "/home/seangmeng/tmp/itc_kh_lex.out")
(lex.set.lts.method 'itc_kh_lts_function)
(if (probe_file (path-append itc_kh_po::dir "festvox/itc_kh_lex.out"))
    (lex.set.compile.file (path-append itc_kh_po::dir 
                                       "festvox/itc_kh_lex.out")))
(itc_kh_addenda)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;
;;; Lexicon setup
;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(define (itc_kh_po::select_lexicon)
  "(itc_kh_po::select_lexicon)
Set up the lexicon for itc_kh."
  (lex.select "itc_kh")

  ;; Post lexical rules
  (set! postlex_rules_hooks (list itc_kh::postlex_rule1))
)

(define (itc_kh_po::reset_lexicon)
  "(itc_kh_po::reset_lexicon)
Reset lexicon information."
  t
)

(provide 'itc_kh_po_lexicon)
