(define (itc_kh_po_pause utt)
  "(Pauses UTT)
Predict pause insertion."
  (let ((words (utt.relation.items utt 'Word)) lastword tpname)
    (if words
	(begin
	  (insert_initial_pause utt)   ;; always have a start pause
	  (set! lastword (car (last words)))
	  (mapcar
	   (lambda (w)
	     (let ((pbreak (item.feat w "pbreak"))
		   (emph (item.feat w "R:Token.parent.EMPH")))
	       (cond
		((or (string-equal "B" pbreak)
		     (or (string-equal "BB" pbreak)
		         (string-equal "mB" pbreak)))
		 (insert_pause utt w))
;		((string-equal emph "1")
;		 (insert_pause utt w))
		((equal? w lastword)
		 (insert_pause utt w)))))
	   words)
	  ;; The embarrassing bit.  Remove any words labelled as punc or fpunc
	  (mapcar
	   (lambda (w)
	     (let ((pos (item.feat w "pos")))
	       (if (or (string-equal "punc" pos)
		       (string-equal "fpunc" pos))
		   (let ((pbreak (item.feat w "pbreak"))
			 (wp (item.relation w 'Phrase)))
		     (if (and (string-matches pbreak "BB?")
			      (item.relation.prev w 'Word))
			 (item.set_feat 
			  (item.relation.prev w 'Word) "pbreak" pbreak))
		     (item.relation.remove w 'Word)
		     ;; can't refer to w as we've just deleted it
		     (item.relation.remove wp 'Phrase)))))
	   words)
          ;; 12/01/2006 V.Strom: Even more embarrasing: Delete all silences
          ;; that are followed by a silence.  These silence sequences 
          ;; emerge if 'punc of phrase-final words consists of more than one 
          ;; character, e.g. period+quote.  That in turn causes problems in 
          ;; build_utts: the 2nd silence ends up with no features but its name, 
          ;; because there is no corresponding 2nd silence in the phone 
          ;; segmentation to align with.
          ;; This schould be fixed in the functions below, but it is easier for
          ;; me to clean up at the end:
          (set! sil (car (car (cdr (car (PhoneSet.description '(silences)))))))
          (set! seg (item.next(utt.relation.first utt 'Segment)))
          (while seg
             ;; (format t "%l %l\n" (item.name seg) (item.name (item.prev seg)))
             (if(and(string-equal sil (item.name seg))
                    (string-equal sil (item.name (item.prev seg))))
                (item.delete (item.prev seg)))
             (set! seg (item.next seg)))))
  utt))


(Parameter.set 'Pause_Method itc_kh_po_pause)
;(print "itc_kh_po_pause")
