;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;                                                                     ;;;
;;;                     Carnegie Mellon University                      ;;;
;;;                  and Alan W Black and Kevin Lenzo                   ;;;
;;;                      Copyright (c) 1998-2000                        ;;;
;;;                        All Rights Reserved.                         ;;;
;;;                                                                     ;;;
;;; Permission is hereby granted, free of charge, to use and distribute ;;;
;;; this software and its documentation without restriction, including  ;;;
;;; without limitation the rights to use, copy, modify, merge, publish, ;;;
;;; distribute, sublicense, and/or sell copies of this work, and to     ;;;
;;; permit persons to whom this work is furnished to do so, subject to  ;;;
;;; the following conditions:                                           ;;;
;;;  1. The code must retain the above copyright notice, this list of   ;;;
;;;     conditions and the following disclaimer.                        ;;;
;;;  2. Any modifications must be clearly marked as such.               ;;;
;;;  3. Original authors' names are not deleted.                        ;;;
;;;  4. The authors' names are not used to endorse or promote products  ;;;
;;;     derived from this software without specific prior written       ;;;
;;;     permission.                                                     ;;;
;;;                                                                     ;;;
;;; CARNEGIE MELLON UNIVERSITY AND THE CONTRIBUTORS TO THIS WORK        ;;;
;;; DISCLAIM ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING     ;;;
;;; ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT  ;;;
;;; SHALL CARNEGIE MELLON UNIVERSITY NOR THE CONTRIBUTORS BE LIABLE     ;;;
;;; FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES   ;;;
;;; WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN  ;;;
;;; AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,         ;;;
;;; ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF      ;;;
;;; THIS SOFTWARE.                                                      ;;;
;;;                                                                     ;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;
;;; Phonset for itc_kh
;;;

;;;  Feeel free to add new feature values, or new features to this
;;;  list to make it more appropriate to your language

;; This is where it'll fall over if you haven't defined a 
;; a phoneset yet, if you have, delete this, if you haven't
;; define one then delete this error message
;;(error "You have not yet defined a phoneset for kh (and others things ?)\n            Define it in festvox/itc_kh_po_phoneset.scm\n")

(defPhoneSet
  itc_kh
  ;;;  Phone Features
  (;; vowel or consonant
   (vc + -)  
   ;; vowel length: short long dipthong schwa
   (vlng s l d a 0)
   ;; vowel height: high mid low
   (vheight 1 2 3 0 -)
   ;; vowel frontness: front mid back
   (vfront 1 2 3 0 -)
   ;; lip rounding
   (vrnd + - 0)
   ;; consonant type: stop fricative nasal latteral approximant
   (ctype s f n l a 0)
   ;; place of articulation: labial alveolar palatal labio-dental
   ;;                         dental velar glotal
   (cplace l a p b d v g 0)
   ;; consonant voicing
   (cvox + - 0)
   ;; consonant aspiration
   (caspiration + - 0)
   )
  (
   (pau - 0 - - - 0 0 - 0)  ;; slience ... 

    (k  - 0 - - 0 s v - -) 
    (kh - 0 - - 0 s v - +)
    (N  - 0 - - 0 n v + -)
    (c  - 0 - - 0 s p - -)
    (ch - 0 - - 0 s p - +)
    (n. - 0 - - 0 n p + -)
    (d  - 0 - - 0 s a + -)
    (n  - 0 - - 0 n a + -)
    (t  - 0 - - 0 s a - -)
    (th - 0 - - 0 s a - +)
    (b  - 0 - - 0 s l + -)
    (p  - 0 - - 0 s l - -)
    (ph - 0 - - 0 s l - +)
    (m  - 0 - - 0 n l + -)
    (j  - 0 - - 0 a p + -)
    (r  - 0 - - 0 a a + -)
    (l  - 0 - - 0 l a + -)
    (w  - 0 - - 0 a l + -)
    (s  - 0 - - 0 f a - -)
    (h  - 0 - - 0 f g - +)
    (?  - 0 - - 0 s g - -)

    (A  + s 0 0 - 0 0 + 0)
    (A: + l 0 0 - 0 0 + 0)
    (O  + s 1 0 + 0 0 + 0)
    (O: + l 1 0 + 0 0 + 0)
    (a  + s 0 3 - 0 0 + 0)
    (a: + l 0 3 - 0 0 + 0)
    (e  + s 2 3 - 0 0 + 0)
    (e: + l 2 3 - 0 0 + 0)
    (@  + s 2 2 - 0 0 + 0)
    (@: + l 2 2 - 0 0 + 0)
    (W: + l 1 3 + 0 0 + 0)
    (@R + l 1 2 + 0 0 + 0)
    (o  + s 2 0 + 0 0 + 0)
    (o: + l 2 0 + 0 0 + 0)
    (i  + s 3 3 - 0 0 + 0)
    (i: + l 3 3 - 0 0 + 0)
    (ix  + s 3 2 - 0 0 + 0)
    (ix: + l 3 2 - 0 0 + 0)
    (u  + s 3 0 + 0 0 + 0)
    (u: + l 3 0 + 0 0 + 0)
    (e. + s 2 2 0 0 0 + 0)
    (e.: + l 2 2 0 0 0 + 0)
    (E: + l 1 3 - 0 0 + 0)
    (Oo + d 1 0 + 0 0 + 0)
    (u@ + d 2 1 + 0 0 + 0)
    (a@ + d 1 2 - 0 0 + 0)
    (ix@ + d 3 2 - 0 0 + 0)
    (iVx + d 2 2 - 0 0 + 0)
    (aE + d 1 3 - 0 0 + 0)
    (ao + d 1 1 + 0 0 + 0)
    (Ea + d 1 3 - 0 0 + 0)
    (oa + d 2 1 + 0 0 + 0)
    (i@ + d 2 2 - 0 0 + 0)

   ;; insert the phones here, see examples in 
   ;; festival/lib/*_phones.scm

  )
)

(PhoneSet.silences '(pau))

(define (itc_kh_po::select_phoneset)
  "(itc_kh_po::select_phoneset)
Set up phone set for itc_kh."
  (Parameter.set 'PhoneSet 'itc_kh)
  (PhoneSet.select 'itc_kh)
)

(define (itc_kh_po::reset_phoneset)
  "(itc_kh_po::reset_phoneset)
Reset phone set for itc_kh."
  t
)

(provide 'itc_kh_po_phoneset)
