#-*- coding: utf-8 -*-
import wx
import os
import word_seg

class Frame(wx.Frame):
    def __init__(self, parent, title):
        wx.Frame.__init__(self, parent, title=title, size=(500,700))
        panel = wx.Panel(self)

        vsizer = wx.BoxSizer(wx.VERTICAL)
        
        font = wx.Font(12, wx.NORMAL, wx.NORMAL, wx.NORMAL)
        self.ori_text = wx.TextCtrl(panel, style=wx.TE_MULTILINE, size=(-1, 300))
        self.ori_text.SetFont(font)
        vsizer.Add(self.ori_text, flag=wx.EXPAND)
        
        hsizer1 = wx.BoxSizer(wx.HORIZONTAL)
        seg_button = wx.Button(panel, label="Segment")
        hsizer1.Add(seg_button)
        
        hsizer1.Add(wx.StaticText(panel, label="Font Size: "), flag=wx.ALIGN_RIGHT|wx.ALIGN_CENTER_VERTICAL)
        tcsize = wx.TextCtrl(panel, value="12")
        bsize = wx.Button(panel, label="Set Size")
        hsizer1.Add(tcsize, flag=wx.ALIGN_RIGHT|wx.ALIGN_CENTER_VERTICAL)
        hsizer1.Add(bsize)
        self.tcsize = tcsize
        self.Bind(wx.EVT_BUTTON, self.ChangeFontSize, bsize)
        
        vsizer.Add(hsizer1)
        
        self.Bind(wx.EVT_BUTTON, self.SegmentIt, seg_button)
        
        vsizer.Add(wx.StaticText(panel, label=""))
        
        self.text = wx.TextCtrl(panel, style=wx.TE_MULTILINE, size=(-1, 300))
        self.text.SetFont(font)
        vsizer.Add(self.text, flag=wx.EXPAND)
        
        hsizer = wx.BoxSizer(wx.HORIZONTAL)
        button = wx.Button(panel, label="Speak")
        self.Bind(wx.EVT_BUTTON, self.SpeakIt, button)
        hsizer.Add(button)
        bsave = wx.Button(panel, label="Save as wave")
        self.Bind(wx.EVT_BUTTON, self.SaveIt, bsave)
        hsizer.Add(bsave)
        
        vsizer.Add(hsizer)
        
        panel.SetSizer(vsizer)
    
    def ChangeFontSize(self, event):
        font = wx.Font(int(self.tcsize.GetValue()), wx.NORMAL, wx.NORMAL, wx.NORMAL)
        self.text.SetFont(font)
        self.ori_text.SetFont(font)
    def ChangeFontSize2(self, event):
        print "2", self.cbsize.GetValue()
    
    def SegmentIt(self, event):
        text = self.ori_text.GetValue().replace(u"​", "")
        text = word_seg.segment_text(text).replace(u"។,", u"។")
        self.text.SetValue(text)
        
    def SpeakIt(self, event):
        self.create_text_file()
        self.run_tts()
	
    def create_text_file(self):
        f = open("tmp_text", "w")
        text = self.text.GetStringSelection().replace(u"។", "\n\n")
        if not text:
            text = self.text.GetValue().replace(u"។", "\n\n")
        f.write(text.encode("utf8"))
        f.close()
        
    def create_tts_file(self):
        f = open("tmp_tts", "w")
        f.write('(voice_itc_kh_po_diphone )\n')
        f.write('(tts "tmp_text" nil)\n')
        f.close()
        
    def run_tts(self):
        os.system("festival --batch tmp_tts")

    def SaveIt(self, event):
        dlg = wx.FileDialog(self, "Save file as..", os.getcwd(), style=wx.SAVE | wx.OVERWRITE_PROMPT)
        if dlg.ShowModal() == wx.ID_OK:
            filename = dlg.GetPath()
            if filename.split(".")[-1] != "wav":
                filename = filename + ".wav"
            #print filename
        self.create_text_file()
        #lines.append("(voice_nitech_us_slt_arctic_hts )\n")
        os.system("text2wave tmp_text -o '%s' -eval '(voice_itc_kh_po_diphone)'" %(filename))
        #os.system("festival --script khtext2wave tmp_text -o \"%s\"" %(filename))
    
class App(wx.App):
    def OnInit(self):
        self.frame = Frame(parent=None, title="TTS: ITC, GIC")
        self.frame.Show()
        self.SetTopWindow(self.frame)
        return True
        
if __name__ == '__main__':
    app = App()
    app.MainLoop()
